//-----------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------
var NAME_OBJECT = "iid";
var NAME_PLACE = "iid_place_holder";
//-----------------------------------------------------------------------
// iid_IsExplorer
//-----------------------------------------------------------------------
function iid_IsExplorer() {
    var explorer = false;
    var info = null;
    if ((info = new DeviceInfo(null)) != null) {
        explorer = info.browser.explorer;
    }
    return explorer;
}
//-----------------------------------------------------------------------
// iid_IsAvailable
//-----------------------------------------------------------------------
function iid_IsAvailable() {
    var available = false;
    var explorer = false;
    var name = null;
    // Always start check for Javascript interface
    if (iid_HasJavascriptInterface()) {
        available = true;
    }
    else {
        // Always use same div id as place holder for create of plugin
        name = NAME_PLACE;
        // Start checking already created
        if (iid_GetObject() != null) {
            available = true;
        }
        // Require place holder defined (used to declare plugin object)
        else if (document.getElementById(name) != null) {
            explorer = iid_IsExplorer();
            // First try Net iD Enterprise plugin
            if (!(available = iid_Declare(name, explorer, false))) {
                // Second try Net iD Live plugin (only explorer)
                if (explorer) {
                    available = iid_Declare(name, explorer, true);
                }
            }
        }
    }
    return available;
}
//-----------------------------------------------------------------------
// iid_HasJavascriptInterface
//-----------------------------------------------------------------------
function iid_HasJavascriptInterface() {
    var available = false;
    if (window.JSInterface != null) {
        if ((window.JSInterface.SetProperty != null) &&
            (window.JSInterface.GetProperty != null) &&
            (window.JSInterface.EnumProperty != null) &&
            (window.JSInterface.Invoke != null)) {
            available = true;
        }
    }
    return available;
}
//-----------------------------------------------------------------------
// iid_GetDeclare
//-----------------------------------------------------------------------
function iid_GetDeclare(explorer, live) {
    var value = "";
    var clsid = "";
    var name = "";
    if (live) {
        name = "application/x-iid-live"
        clsid = "5BF56AD2-E297-416E-BC49-00B327C4428E";
    }
    else {
        name = "application/x-iid"
        clsid = "5BF56AD2-E297-416E-BC49-00B327C4426E";
    }
    if (explorer) {
        value = "<object name='" + NAME_OBJECT + "' id='" + NAME_OBJECT + "' classid='CLSID:";
        value += clsid;
        value += "' width='0' height='0'></object>";
    }
    else {
        value = "<object name='" + NAME_OBJECT + "' id='" + NAME_OBJECT + "' type='";
        value += name;
        value += "' width='0' height='0'></object>";
    }
    return value;
}
//-----------------------------------------------------------------------
// iid_GetObject
//-----------------------------------------------------------------------
function iid_GetObject() {
    var obj = null;
    if (iid_HasJavascriptInterface()) {
        obj = window.JSInterface;
    }
    else {
        obj = document.getElementById(NAME_OBJECT);
    }
    return obj;
}
//-----------------------------------------------------------------------
// iid_Declare
//-----------------------------------------------------------------------
function iid_Declare(name, explorer, live) {
    var success = false;
    var iid_place = null;
    var iid_object = null;
    var version = 0;
    var count = 0;
    iid_place = document.getElementById(name);
    if (iid_place != null) {
        // Get object declaration
        iid_place.innerHTML = iid_GetDeclare(explorer, live);
        // Require plugin object return something useful
        version = iid_GetProperty("Version");
        if ((version != null) && (version.length > 0)) {
            success = true;
        }
        // Problem with dynamic loading for Firefox, so check for special object
        if (!success && !explorer) {
            if (NAME_OBJECT.indexOf("ns_") == -1) {
                NAME_OBJECT = "ns_" + NAME_OBJECT;
                success = (iid_GetObject() != null);
            }
        }
    }
    return success;
}
//-----------------------------------------------------------------------------
// iid_SetProperty
//-----------------------------------------------------------------------------
function iid_SetProperty(name, value) {
    var iid = iid_GetObject();
    if (iid != null) {
        try {
            iid.SetProperty(name, value);
        }
        catch (err) { }
    }
    return;
}
//-----------------------------------------------------------------------------
// iid_GetProperty
//-----------------------------------------------------------------------------
function iid_GetProperty(name) {
    var value = "";
    var iid = iid_GetObject();
    if (iid != null) {
        try {
            value = iid.GetProperty(name);
        }
        catch (err) {
        }
    }
    return value;
}
//-----------------------------------------------------------------------------
// iid_EnumProperty
//-----------------------------------------------------------------------------
function iid_EnumProperty(name, index) {
    var value = "";
    var iid = iid_GetObject();
    if (iid != null) {
        try {
            value = iid.EnumProperty(name, index);
        }
        catch (err) { }
    }
    return value;
}
//-----------------------------------------------------------------------------
// iid_Invoke
//-----------------------------------------------------------------------------
function iid_Invoke(name) {
    var value = "";
    var iid = iid_GetObject();
    if (iid != null) {
        try {
            value = iid.Invoke(name);
        }
        catch (err) { }
    }
    return value;
}
