//-----------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------
var CERTIFICATE = null;
var TYPE = null;
//-----------------------------------------------------------------------
// OnLoad
//-----------------------------------------------------------------------
function OnLoad() {
    var vars = null;
    var value = null;
    var certificate = null;
    var type = null;
    if ((vars = GetVariablesHREF()) != null) {
        // Need to restore variables after "back" button 
        if (vars.length == 0) {
            vars = RestoreAllVariables();
        }
        else {
            vars = AppendToAllVariables(vars);
        }
        if (vars.length > 0) {
            if ((value = vars["selected"]) != null) {
                type = vars["type"];
                if ((certificate = ParseCertificateInfo(value)) != null) {
                    SetCertificateInfo(certificate, type);
                    ShowElements(vars["ConfigGlobal:Administration:View"]);
                    EnableElements();
                    // Remember certificate for later use
                    CERTIFICATE = certificate;
                    TYPE = type;
                    ShowHeader();
                    // Show whole content
                    SetElementVisible("content");
                }
            }
        }
        else {
            OnBack();
        }
    }
    return;
}
//-----------------------------------------------------------------------
// SetCertificateInfo
//-----------------------------------------------------------------------
function SetCertificateInfo(certificate, type) {
    var value = null;
    var i = 0;
    var name = null;
    if (certificate != null) {
        // Certificate information
        SetElementValue("title", GetString("TITLE_CERTIFICATE"));
        SetElementLabel("name", certificate.name);
        if (certificate.company != null) {
            SetElementLabel("text", certificate.company);
        }
        else {
            SetElementHidden("text");
        }
        //SetElementValue("info", certificate.validTo);
        SetElementHidden("info");
        if ((value = GetCertificateImageByName(certificate)) != null) {
            SetElementImage("image", value);
        }
        else {
            SetElementDefaultImage("image", "certificate_" + type);
        }
        // Set all strings
        SetElementValue("actions", GetString("TEXT_ACTIONS"));
        SetElementValue("view_name", GetString("TEXT_VIEW_CERTIFICATE"));
        SetElementValue("view_text", GetString("INFO_VIEW_CERTIFICATE"));
        SetElementDefaultImage("view_image", "details");
        SetElementValue("open_name", GetString("TEXT_OPEN_CERTIFICATE"));
        SetElementValue("open_text", GetString("INFO_OPEN_CERTIFICATE"));
        SetElementDefaultImage("open_image", "open");
        SetElementValue("delete_name", GetString("TEXT_DELETE_CERTIFICATE"));
        SetElementValue("delete_text", GetString("INFO_DELETE_CERTIFICATE"));
        SetElementDefaultImage("delete_image", "delete");
    }
    return;
}
//-----------------------------------------------------------------------
// OnBack
//-----------------------------------------------------------------------
function OnBack() {
    LoadPage("token_certs", null);
    return;
}
//-----------------------------------------------------------------------
// OnView
//-----------------------------------------------------------------------
function OnView(elem) {
    value = "type=" + TYPE + "&";
    value += "selected=" + URL.encode(PackCertificateInfo(CERTIFICATE)) + "&";
    value += "back=certificate";
    LoadPage("certificate_view", value);
    return;
}
//-----------------------------------------------------------------------
// OnOpen
//-----------------------------------------------------------------------
function OnOpen() {
    var value = null;
    value = "Certificate=" + CERTIFICATE.certID;
    document.form1.next.value = "none";
    CallPluginComponent(document.form1.next.value, "plugin", value, "ViewCertificate", "", "")    
    return;
}
//-----------------------------------------------------------------------
// OnCopy
//-----------------------------------------------------------------------
function OnCopy() {
    CopyClipboard(CERTIFICATE.certID);
    return;
}
//-----------------------------------------------------------------------
// OnDelete
//-----------------------------------------------------------------------
function OnDelete() {
    if (CERTIFICATE != null) {
        ShowConfirm(GetString("CONFIRM_DELETE_CERTIFICATE"), null, CallDelete, null);
    }
    return;
}
//-----------------------------------------------------------------------
// CallDelete
//-----------------------------------------------------------------------
function CallDelete() {
    ShowProgress();
    document.form1.next.value = "index.html";
    LoadPluginVariables("Certificate=" + CERTIFICATE.certID, "DeleteCertificate");
    return;
}
//-----------------------------------------------------------------------
// ShowElements
//-----------------------------------------------------------------------
function ShowElements(view) {
    view = GetPartBy(GetPartBy(view, 0, ';'), 4, ',');
    ShowElementList(view, "view;open;copy;delete");
    return;
}
//-----------------------------------------------------------------------
// EnableElements
//-----------------------------------------------------------------------
function EnableElements() {
    // Sometimes not updatable
    if (!MayUpdateTokens()) {
        SetElementHidden("delete");
    }
    // Some platforms does not support external certificate viewer 
    if (!IsOpenCertificateAvailable()) {
        SetElementHidden("open");
    }
    return;
}
