//-----------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------
var COPY_TEXT = null;
//-----------------------------------------------------------------------
// OnLoad
//-----------------------------------------------------------------------
function OnLoad() {
    var vars = null;
    var value = null;
    var certificate = null;
    var type = null;
    if ((vars = GetVariablesHREF()) != null) {
        if ((value = vars["selected"]) != null) {
            type = vars["type"];
            if ((certificate = ParseCertificateInfo(value)) != null) {
                SetCertificateInfo(certificate, type);
                COPY_TEXT = GetCopyCertificateInfo(certificate); 
                ShowElements(vars["ConfigGlobal:Administration:View"]);
                EnableElements(certificate);
                ShowHeader();
                // Show whole content
                SetElementVisible("content");
            }
        }
    }
    return;
}
//-----------------------------------------------------------------------
// SetCertificateInfo
//-----------------------------------------------------------------------
function SetCertificateInfo(certificate, type) {
    var value = null;
    var i = 0;
    var name = null;
    if (certificate != null) {
        // Certificate information
        SetElementValue("title", GetString("TITLE_CERTIFICATE"));
        SetElementLabel("name", certificate.name);
        SetElementLabel("text", certificate.company);
        //SetElementValue("info", certificate.validTo);
        SetElementHidden("info");
        if ((value = GetCertificateImageByName(certificate)) != null) {
            SetElementImage("image", value);
        }
        else {
            SetElementDefaultImage("image", "certificate_" + type);
        }
        // Userid
        if (certificate.personalNumber.length > 0) {
            SetElementValue("userid_name", GetString("TEXT_USERID"));
            SetElementValue("userid_text", FormatPersonalNumber(certificate.personalNumber));
        }
        // Subject
        SetElementValue("subject_name", GetString("TEXT_SUBJECT"));
        SetElementValue("subject_text", FormatRDN(certificate.subject));
        // Issuer
        SetElementValue("issuer_name", GetString("TEXT_ISSUER"));
        SetElementValue("issuer_text", FormatRDN(certificate.issuer));
        // Usage
        SetElementValue("usage_name", GetString("TEXT_USAGE"));
        value = "";
        for (i = 1; i < 8; i++) {
            if (parseInt(certificate.usage) & (1 << i)) {
                switch (1 << i) {
                    case 0x80: name = GetString("TEXT_USAGE_DIGSIG"); break;
                    case 0x40: name = GetString("TEXT_USAGE_NONREP"); break;
                    case 0x20: name = GetString("TEXT_USAGE_KEYENC"); break;
                    case 0x10: name = GetString("TEXT_USAGE_DATAENC"); break;
                    case 0x08: name = GetString("TEXT_USAGE_KEYEAGREE"); break;
                    case 0x04: name = GetString("TEXT_USAGE_CERTSIGN"); break;
                    case 0x02: name = GetString("TEXT_USAGE_CRLSIGN"); break;
                    default: name = null;
                }
                if (name != null) {
                    if (value.length == 0) {
                        value = name;
                    }
                    else {
                        value += "<br />" + name;
                    }
                }
            }
        }
        SetElementValue("usage_text", value);
        // Validity
        SetElementValue("validity_name", GetString("TEXT_VALIDITY"));
        SetElementValue("validity_from", certificate.validFrom);
        SetElementValue("validity_to", certificate.validTo);
        // Certificate identifiers
        SetElementValue("authkeyid_name", GetString("TEXT_AUTHKEYID"));
        SetElementValue("authkeyid_text", certificate.authID);
        SetElementValue("thumbprint_name", GetString("TEXT_THUMBPRINT"));
        SetElementValue("thumbprint_text", certificate.certID);
    }
    return;
}
//-----------------------------------------------------------------------
// GetCopyCertificateInfo
//-----------------------------------------------------------------------
function GetCopyCertificateInfo(certificate) {
    var value = null;
    if (certificate != null) {
        value = certificate.name + "\n";
        if (certificate.company != null) {
            value += certificate.company + "\n";
        }
        if (certificate.personalNumber.length > 0) {
            value += FormatPersonalNumber(certificate.personalNumber) + "\n";
        }
        value += "\n";
        value += certificate.subject + "\n";
        value += certificate.issuer + "\n";
        value += "\n";
        value += certificate.certID + "\n";
    }
    return value;
}
//-----------------------------------------------------------------------
// OnBack
//-----------------------------------------------------------------------
function OnBack() {
    var vars = GetVariablesHREF();
    var value = null;
    var certificate = null;
    var type = null;
    if ((value = vars["selected"]) != null) {
        type = vars["type"];
        if ((certificate = ParseCertificateInfo(value)) != null) {
            value = "type=" + type + "&";
            value += "selected=" + URL.encode(PackCertificateInfo(certificate));
            if ((type = vars["back"]) == null) {
                type = "certificate";
            }
            LoadPage(type, value);
        }
    }
    return;
}
//-----------------------------------------------------------------------
// OnCopyAll
//-----------------------------------------------------------------------
function OnCopyAll() {
    if (COPY_TEXT != null) {
        CopyClipboard(COPY_TEXT);
    }
    return;
}
//-----------------------------------------------------------------------
// OnCopy
//-----------------------------------------------------------------------
function OnCopy(text) {
    CopyClipboard(text);
    return;
}
//-----------------------------------------------------------------------
// ShowElements
//-----------------------------------------------------------------------
function ShowElements(view) {
    view = GetPartBy(GetPartBy(view, 0, ';'), 5, ',');
    ShowElementList(view, "userid;subject;issuer;validity;usage;authkeyid;thumbprint");
    return;
}
//-----------------------------------------------------------------------
// EnableElements
//-----------------------------------------------------------------------
function EnableElements(certificate) {
    // Hide if value missing
    if (certificate.personalNumber.length == 0) {
        SetElementHidden("userid");
    }
    if (certificate.authID.length == 0) {
        SetElementHidden("authkeyid");
    }
    return;
}
