﻿//-----------------------------------------------------------------------
// OnLoad
//-----------------------------------------------------------------------
function OnLoad() {
    var vars = GetVariablesHREF();
    // Set variable information, use default for empty (demo)
    if (vars["title"] == null) {
        vars["title"] = "Windows security";
        vars["subtitle"] = "What do you want the computer to do?";
        vars["info"] = "Lock is automatically selected in <timeout> seconds.";
        vars["timeout"] = "10000";
        vars["default"] = "Lock";
        vars["buttons"] = "lock,Lock;logout,Logout;restart,Restart;shutdown,Shutdown;sleep,Sleep;hibernate,Hibernate;none,Cancel";
    }
    SetInformation(vars);
    // Show the whole content
    SetElementVisible("content");
    return;
}
//-----------------------------------------------------------------------
// SetInformation
//-----------------------------------------------------------------------
function SetInformation(vars) {
    SetViewTheme(vars["theme"]);
    SetCurrentLanguage(vars);
    SetElementLabel("title", vars["title"]);
    SetElementLabel("subtitle", vars["subtitle"]);
    SetCounterInfo(vars["info"], vars["timeout"]);
    SetDefaultButton(vars["default"]);
    SetButtons(vars["buttons"]);
    SetFieldFocus("body");
    return;
}
//-----------------------------------------------------------------------
// SetCounterInfo
//-----------------------------------------------------------------------
function SetCounterInfo(text, timeout) {
    if ((text != null) && (text != "") && (timeout != null) && (timeout != "")) {
        text = text.replace("<timeout>", "<span id='timeout'>" + timeout + "</span>");
        SetElementValue("auto", text);
        setTimeout(UpdateCounterInfo, 1000);
    }
    return;
}
//-----------------------------------------------------------------------
// UpdateCounterInfo
//-----------------------------------------------------------------------
function UpdateCounterInfo() {
    var elem = null;
    var value = "";
    var timeout = 0;
    if ((elem = document.getElementById("timeout")) != null) {
        timeout = Number(elem.innerHTML);
        if (timeout == 1) {
            OnButton(document.form1.response.value);
        }
        else {
            timeout--;
            elem.innerHTML = String(timeout);
            setTimeout(UpdateCounterInfo, 1000);
        }
    }
    return;
}
//-----------------------------------------------------------------------
// SetDefaultButton
//-----------------------------------------------------------------------
function SetDefaultButton(value) {
    if (value != null) {
        document.form1.response.value = value;
    }
    return;
}
//-----------------------------------------------------------------------
// SetButtons
//-----------------------------------------------------------------------
function SetButtons(list) {
    var elem = null;
    var innerHTML = "";
    var value = "";
    var value2 = "";
    var info = "";
    var i = 0;
    var allowCancel = false;
    if (list != null) {
        if ((elem = document.getElementById("btn")) != null) {
            innerHTML = elem.innerHTML;
            elem.innerHTML = "";
            while ((value = GetPartBy(list, i++, ';')) != "") {
                info = innerHTML;
                value2 = GetPartBy(value, 0, ',');
                if (value2 == "none") {
                    allowCancel = true;
                    value2 = GetPartBy(value, 1, ',');
                    SetElementValue("btn_cancel", GetPartBy(value2, 0, ':'));
                }
                else {
                    if (value2 == document.form1.response.value) {
                        info = info.replace("tile", "tile_selected");
                    }
                    info = ReplaceAll(info, "BUTTON_COMMAND", value2);
                    value2 = GetPartBy(value, 1, ',');
                    info = ReplaceAll(info, "BUTTON_TEXT1", GetPartBy(value2, 0, ':'));
                    info = ReplaceAll(info, "BUTTON_TEXT2", GetPartBy(value2, 1, ':'));
                    info = info.replace("hidden", "visible");
                    elem.innerHTML += info;
                }
            }
            if (!allowCancel) {
                SetElementHidden("abort");
            }
        }
    }
    return;
}
//-----------------------------------------------------------------------
// OnButton
//-----------------------------------------------------------------------
function OnButton(value) {
    document.form1.status.value = "CKR_OK";
    document.form1.response.value = value;
    document.form1.action = "iid://exit";
    document.form1.submit();
    return;
}
//-----------------------------------------------------------------------
// OnButtonCancel
//-----------------------------------------------------------------------
function OnButtonCancel(value) {
    document.form1.status.value = "CKR_CANCEL";
    document.form1.response.value = "";
    document.form1.action = "iid://exit";
    document.form1.submit();
    return;
}
//-----------------------------------------------------------------------
// OnButtonOK
//-----------------------------------------------------------------------
function OnButtonOK() {
    OnButton(document.form1.response.value);
    return;
}
