﻿//-----------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------
var SLOTID = null;
var CERTIFICATE = null;
//-----------------------------------------------------------------------
// OnLoad
//-----------------------------------------------------------------------
function OnLoad() {
    var vars = null;
    if ((vars = GetVariablesHREF()) != null) {
        // Set variable information, use default for empty (demo)
        if (vars["title"] == null) {
            vars["title"] = "Insert smart card";
            vars["subtitle"] = "Insert smart card which containing the following certificate";
            vars["picture"] = "def_card.png";
            vars["name"] = "Test Testsson";
            vars["above"] = "Company AB";
            vars["below"] = "More information";
        }
        SLOTID = vars["slotid"];
        CERTIFICATE = vars["certificate"];
        SetInformation(vars);
        // Show the whole content
        SetElementVisible("content");
        // We reuqire plugin object, so Cancel if object missing
        if (!iid_IsAvailable()) {
            OnButtonCancel();
        }
        else {
            // Check for token/certificate events
            setTimeout(OnTimeout, 999);
        }
    }
    return;
}
//-----------------------------------------------------------------------
// SetInformation
//-----------------------------------------------------------------------
function SetInformation(vars) {
    SetViewTheme(vars["theme"]);
    SetCurrentLanguage(vars);
    SetElementLabel("title", vars["title"]);
    SetElementLabel("subtitle", vars["subtitle"]);
    if ((vars["picture"] != null) && (vars["picture"] != "")) {
        SetElementImage("image", vars["picture"]);
    }
    SetElementLabel("name", vars["name"]);
    if ((vars["above"] != null) && (vars["above"] != "")) {
        SetElementLabel("above", vars["above"]);
    }
    else {
        SetElementHidden("above");
    }
    if ((vars["below"] != null) && (vars["below"] != "")) {
        SetElementLabel("below", vars["below"]);
    }
    else {
        SetElementHidden("below");
    }
    SetButtonValues(vars["buttons"]);
    return;
}
//-----------------------------------------------------------------------
// SetButtonValues
//-----------------------------------------------------------------------
function SetButtonValues(value) {
    if (value != null) {
        SetElementButton("btn_cancel", GetPartBy(value, 1, ';'));
    }
    return;
}
//-----------------------------------------------------------------------
// OnButtonOK
//-----------------------------------------------------------------------
function OnButtonOK() {
    // Same as Cancel, since implementation will check for presence after
    // dialog finished
    OnButtonCancel();
    return;
}
//-----------------------------------------------------------------------
// OnButtonCancel
//-----------------------------------------------------------------------
function OnButtonCancel() {
    document.form1.action = "iid://exit";
    document.form1.submit();
    return;
}
//-----------------------------------------------------------------------
// OnButtonView
//-----------------------------------------------------------------------
function OnButtonView() {
    // Clear plugin information
    iid_Invoke("Reset");
    // Either certificate or slotid will be present
    if ((CERTIFICATE != null) && (CERTIFICATE.length > 0)) {
        iid_SetProperty("Certificate", CERTIFICATE);
        iid_Invoke("ViewCertificate");
    }
    return;
}
//-----------------------------------------------------------------------
// OnTimeout
//-----------------------------------------------------------------------
function OnTimeout() {
    // Clear plugin information
    iid_Invoke("Reset");
    // Either certificate or slotid will be present
    if ((CERTIFICATE != null) && (CERTIFICATE.length > 0)) {
        iid_SetProperty("Certificate", CERTIFICATE);
        if (iid_GetProperty("CertificatePresent") == "true") {
            OnButtonOK();
        }
    }
    else if ((SLOTID != null) && (SLOTID.length > 0)) {
        iid_SetProperty("ActiveSlot", SLOTID);
        if (iid_GetProperty("TokenPresent") == "true") {
            OnButtonOK();
        }
    }
    setTimeout(OnTimeout, 999);
    return;
}
