﻿//-----------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------
var SLOTID = null;
var NUMBER = null;
var CONTEXT = null;
//-----------------------------------------------------------------------
// OnLoad
//-----------------------------------------------------------------------
function OnLoad() {
    var vars = GetVariablesHREF();
    var value = null;
    // Set variable information, use default for empty (demo)
    if (vars["title"] == null) {
        vars["slotid"] = "1";
        vars["title"] = "Open";
        vars["subtitle"] = "Enter PIN for Net iD Access (basic)";
        vars["picture"] = "def_card.png";
        vars["name"] = "Test Testsson";
        vars["above"] = "Company AB";
        vars["below"] = "WARNING: Last attempt.";
    }
    if ((SLOTID = vars["slotid"]) != null) {
        NUMBER = vars["number"];
        CONTEXT = vars["context"];
        // Set active information
        SetInformation(vars);
        // First call or response to logon attempt?
        if ((value = vars["result"]) != null) {
            // Exit on success and report error on failure
            if (value == "CKR_OK") {
                OnButtonExit("CKR_OK", vars["Protected|Password"]);
            }
            else {
                ShowErrorPkcs11(value);
            }
        }
        // Show the whole content
        SetElementVisible("content");
        // Set focus on password field (unless result response)
        if (value == null) {
            SetFieldFocus("pwd");
        }
    }
    return;
}
//-----------------------------------------------------------------------
// SetInformation
//-----------------------------------------------------------------------
function SetInformation(vars) {
    SetViewTheme(vars["theme"]);
    SetCurrentLanguage(vars);
    SetElementLabel("title", vars["title"]);
    SetElementLabel("subtitle", vars["subtitle"]);
    if ((vars["picture"] != null) && (vars["picture"] != "")) {
        SetElementImage("image", vars["picture"]);
    }
    else if (SLOTID < 100) {
        SetElementDefaultImage("image", "token_card");
    }
    else {
        SetElementDefaultImage("image", "token_soft");
    }
    SetElementLabel("name", vars["name"]);
    SetElementLabel("above", vars["above"]);
    SetWarning(URL.decode(vars["PasswordStatus"]));
    SetButtonValues(vars["buttons"]);
    SetOperationType(vars["operation"]);
    UpdateLanguage();
    return;
}
//-----------------------------------------------------------------------
// SetButtonValues
//-----------------------------------------------------------------------
function SetButtonValues(value) {
    if (value != null) {
        SetElementButton("btn_ok", GetPartBy(value, 0, ';'));
        SetElementButton("btn_ok2", GetPartBy(value, 0, ';'));
        SetElementButton("btn_cancel", GetPartBy(value, 1, ';'));
    }
    return;
}
//-----------------------------------------------------------------------
// SetWarning
//-----------------------------------------------------------------------
function SetWarning(value) {
    if ((value != null) && (value.length > 0)) {
        SetElementLabel("below", value);
        SetElementVisible("warning");
    }
    else {
        SetElementHidden("warning");
    }
    return;
}
//-----------------------------------------------------------------------
// SetOperationType
//-----------------------------------------------------------------------
function SetOperationType(value) {
    switch (value) {
        case "1": SetElementClass("password_image", "image_cert"); break;
        default: SetElementClass("password_image", "image_none"); break;
    }
    return;
}
//-----------------------------------------------------------------------
// UpdateLanguage
//-----------------------------------------------------------------------
function UpdateLanguage() {
    SetElementLabel("label_password", GetString("TEXT_PIN"));
    return;
}
//-----------------------------------------------------------------------
// OnButtonOK
//-----------------------------------------------------------------------
function OnButtonOK() {
    var value = "";
    var rv = 0;
    if (document.form1.pwd.value.length > 0) {
        if (iid_IsAvailable()) {
            iid_Invoke("Reset");
            if ((SLOTID >= 100) && (NUMBER != null) && (NUMBER.length > 0)) {
                iid_SetProperty("ActiveSlot", NUMBER);
            }
            else {
                iid_SetProperty("ActiveSlot", SLOTID);
            }
            iid_SetProperty("Password", document.form1.pwd.value);
            document.form1.pwd.value = "";
            if ((rv = iid_Invoke("Login")) == 0) {
                iid_SetProperty("Key", CONTEXT);
                value = iid_GetProperty("Protected|Password");
                OnButtonExit("CKR_OK", value);
            }
            else {
                ShowErrorPkcs11(GetPartBy(iid_GetProperty("Error " + rv), 0, ';'));
                SetWarning(URL.decode(iid_GetProperty("PasswordStatus")));
            }
        }
        else {
            value += "ActiveSlot=" + SLOTID + ";";
            value += "Password=" + URL.encode(document.form1.pwd.value) + ";";
            document.form1.pwd.value = "";
            document.form1.iid_set.value = value;
            document.form1.iid_invoke.value = "Login";
            document.form1.iid_get.value = "PasswordStatus;Protected|Password";
            document.form1.action = "iid://plugin";
            document.form1.submit();
        }
    }
    return;
}
//-----------------------------------------------------------------------
// OnButtonCancel
//-----------------------------------------------------------------------
function OnButtonCancel() {
    OnButtonExit("CKR_CANCEL", null);
    return;
}
//-----------------------------------------------------------------------
// OnButtonExit
//-----------------------------------------------------------------------
function OnButtonExit(result, response) {
    document.form1.action = "iid://exit";
    document.form1.status.value = result;
    if (response != null) {
        document.form1.response.value = response;
    }
    document.form1.submit();
    return;
}
