﻿//-----------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------
var SLOTID = null;
var NUMBER = null;
var TYPE = null;
//-----------------------------------------------------------------------
// OnLoad
//-----------------------------------------------------------------------
function OnLoad() {
    var vars = GetVariablesHREF();
    var value = null;
    // Set variable information, use default for empty (demo)
    if (vars["title"] == null) {
        vars["slotid"] = "1";
        vars["title"] = "Change PIN";
        vars["subtitle"] = "Change PIN for Net iD Access (basic)";
        vars["picture"] = "def_card.png";
        vars["name"] = "";
        vars["above"] = "";
        vars["below"] = "WARNING: Last attempt.";
    }
    if ((SLOTID = vars["slotid"]) != null) {
        NUMBER = vars["number"];
        // Set active information
        SetInformation(vars);
        // First call or response to logon attempt?
        if ((value = vars["result"]) != null) {
            // Report error on failure
            if (value == "CKR_OK") {
                SetElementLabel("below", "");
                if (TYPE == "change") {
                    ShowMessage(GetString("INFO_PIN_CHANGED"));
                }
                else {
                    ShowMessage(GetString("INFO_PIN_UNLOCKED"));
                }
            }
            else {
                ShowErrorPkcs11(value);
            }
        }
        // Show the whole content
        SetElementVisible("content");
        // Set focus on old password field
        if (value == null) {
            SetFieldFocus("pwd_old");
        }
    }
    return;
}
//-----------------------------------------------------------------------
// SetInformation
//-----------------------------------------------------------------------
function SetInformation(vars) {
    var value = null;
    SetCurrentLanguage(vars);
    SetViewTheme(vars["theme"]);
    SetElementLabel("title", vars["title"]);
    SetElementLabel("subtitle", vars["subtitle"]);
    if ((vars["picture"] != null) && (vars["picture"] != "")) {
        SetElementImage("image", vars["picture"]);
    }
    else if (SLOTID < 100) {
        SetElementDefaultImage("image", "token_card");
    }
    else {
        SetElementDefaultImage("image", "token_soft");
    }
    SetElementLabel("name", vars["name"]);
    SetElementLabel("above", vars["above"]);
    SetWarning(URL.decode(vars["PasswordStatus"]));
    SetButtonValues(vars["buttons"]);
    SetOperationType(vars["operation"]);
    UpdateLanguage();
    return;
}
//-----------------------------------------------------------------------
// SetButtonValues
//-----------------------------------------------------------------------
function SetButtonValues(value) {
    if (value != null) {
        SetElementButton("btn_ok", GetPartBy(value, 0, ';'));
        SetElementButton("btn_cancel", GetPartBy(value, 1, ';'));
        SetElementButton("popup_btn_ok", GetPartBy(value, 0, ';'));
        SetElementButton("popup_btn_cancel", GetPartBy(value, 1, ';'));
    }
    return;
}
//-----------------------------------------------------------------------
// SetWarning
//-----------------------------------------------------------------------
function SetWarning(value) {
    if ((value != null) && (value.length > 0)) {
        SetElementLabel("below", value);
        SetElementVisible("warning");
    }
    else {
        SetElementHidden("warning");
    }
    return;
}
//-----------------------------------------------------------------------
// SetOperationType
//-----------------------------------------------------------------------
function SetOperationType(value) {
    switch (value) {
        case "0": TYPE = "change"; break;
        case "1": TYPE = "unlock"; break;
    }
    return;
}
//-----------------------------------------------------------------------
// UpdateLanguage
//-----------------------------------------------------------------------
function UpdateLanguage() {
    if (TYPE == "change") {
        SetElementLabel("label_password", GetString("TEXT_PIN"));
    }
    else {
        SetElementLabel("label_password", GetString("TEXT_PUK"));
    }
    SetElementLabel("label_newpassword", GetString("TEXT_NEWPIN"));
    SetElementLabel("label_confirmpassword", GetString("TEXT_CONFIRMPIN"));
    return;
}
//-----------------------------------------------------------------------
// OnButtonOK
//-----------------------------------------------------------------------
function OnButtonOK() {
    var rv = 0;
    var value = "";
    if (iid_IsAvailable()) {
        iid_Invoke("Reset");
        if ((SLOTID >= 100) && (NUMBER != null) && (NUMBER.length > 0)) {
            iid_SetProperty("ActiveSlot", NUMBER);
        }
        else {
            iid_SetProperty("ActiveSlot", SLOTID);
        }
        iid_SetProperty("NewPassword", document.form1.pwd_new.value);
        iid_SetProperty("ConfirmPassword", document.form1.pwd_confirm.value);
        if (TYPE == "change") {
            iid_SetProperty("Password", document.form1.pwd_old.value);
            if ((rv = iid_Invoke("ChangePassword")) == 0) {
                ShowMessage(GetString("INFO_PIN_CHANGED"));
            }
        }
        else {
            iid_SetProperty("UnlockPassword", document.form1.pwd_old.value);
            if ((rv = iid_Invoke("UnlockPassword")) == 0) {
                ShowMessage(GetString("INFO_PIN_UNLOCKED"));
            }
        }
        document.form1.pwd_old.value = "";
        document.form1.pwd_new.value = "";
        document.form1.pwd_confirm.value = "";
        SetFieldFocus("pwd_confirm");
        SetFieldFocus("pwd_new");
        SetFieldFocus("pwd_old");
        if (rv != 0) {
            ShowErrorPkcs11(GetPartBy(iid_GetProperty("Error " + rv), 0, ';'));
            SetWarning(URL.decode(iid_GetProperty("PasswordStatus")));
        }
        else {
            SetWarning(null);
        }
        SetFieldFocus("popup_type");
    }
    else {
        value += "ActiveSlot=" + SLOTID + ";";
        value += "NewPassword=" + URL.encode(document.form1.pwd_new.value) + ";";
        value += "ConfirmPassword=" + URL.encode(document.form1.pwd_confirm.value) + ";";
        if (TYPE == "change") {
            value += "Password=" + URL.encode(document.form1.pwd_old.value) + ";";
        }
        else {
            value += "UnlockPassword=" + URL.encode(document.form1.pwd_old.value) + ";";
        }
        document.form1.iid_set.value = value;
        if (TYPE == "change") {
            document.form1.iid_invoke.value = "ChangePassword";
        }
        else {
            document.form1.iid_invoke.value = "UnlockPassword";
        }
        document.form1.iid_get.value = "PasswordStatus";
        document.form1.action = "iid://plugin";
        document.form1.submit();
    }
    return;
}
//-----------------------------------------------------------------------
// OnButtonCancel
//-----------------------------------------------------------------------
function OnButtonCancel() {
    OnButtonExit("CKR_CANCEL");
    return;
}
//-----------------------------------------------------------------------
// OnButtonExit
//-----------------------------------------------------------------------
function OnButtonExit(result) {
    document.form1.action = "iid://exit";
    document.form1.status.value = result;
    document.form1.submit();
    return;
}
