﻿//-----------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------
var SLOTID = 0;
//-----------------------------------------------------------------------
// OnLoad
//-----------------------------------------------------------------------
function OnLoad() {
    var vars = GetVariablesHREF();
    // Set variable information, use default for empty (demo)
    if (vars["label"] == null) {
        vars["label"] = "Net iD Access";
        vars["picture"] = "";
        vars["number"] = "2E4E 4554 5701 1351 209C 7D04 511D FFFF";
        vars["model"] = "Gemalto .NET Smart Card 6.0.0"
        vars["slot"] = "OMNIKEY CardMan 6321 0";
        vars["certificates"] = "11223344,Sebastian de Maré,SecMaker CA v02,2013-01-01,160;11223344,Magnus Alström,Telia e-legitimation EU HW CA v1,2013-01-01,64;11223344,Jonas Söderberg,SecMaker CA v02,2013-01-01,160";
    }
    SetInformation(vars);
    // Show the whole content
    SetElementVisible("content");
    return;
}
//-----------------------------------------------------------------------
// SetInformation
//-----------------------------------------------------------------------
function SetInformation(vars) {
    SLOTID = vars["slotid"];
    SetViewTheme(vars["theme"]);
    SetCurrentLanguage(vars);
    if ((vars["picture"] != null) && (vars["picture"] != "")) {
        SetElementImage("image", vars["picture"]);
    }
    else if (SLOTID < 100) {
        SetElementDefaultImage("image", "token_card");
    }
    else {
        SetElementDefaultImage("image", "token_soft");
    }
    SetElementLabel("label", vars["label"]);
    SetElementLabel("number", vars["number"]);
    SetElementLabel("model", vars["manufacturer"] + " " + vars["model"]);
    if (SLOTID < 100) {
        SetElementLabel("slot", vars["slot"]);
    }
    else {
        SetElementHidden("slot_link");
    }
    SetButtonValues(vars["buttons"]);
    SetCertificates(vars["certificates"]);
    return;
}
//-----------------------------------------------------------------------
// CreateCertificatesList
//-----------------------------------------------------------------------
function CreateCertificatesList(info) {
    var elem = null;
    var innerHTML = "";
    var value = "";
    var i = 0;
    if ((elem = document.getElementById("elem0")) != null) {
        innerHTML = elem.innerHTML;
        elem.innerHTML = "";
        while (GetPartBy(info, i, ';') != "") {
            value = innerHTML;
            value = value.replace("'0'", "'" + i + "'");
            value = value.replace("view0", "view" + i);
            value = value.replace("elem0", "elem" + i);
            value = value.replace("name0", "name" + i);
            value = value.replace("issuer0", "issuer" + i);
            value = value.replace("expire0", "expire" + i);
            elem.innerHTML += value;
            i++;
        }
    }
    return;
}
//-----------------------------------------------------------------------
// SetCertificates
//-----------------------------------------------------------------------
function SetCertificates(info) {
    var part = "";
    var elem = null;
    var i = 0;
    if (info == null)
        info = "";
    CreateCertificatesList(info);
    while ((part = GetPartBy(info, i, ';')) != "") {
        SetElementLabel("name" + i, GetPartBy(part, 1, ','));
        SetElementLabel("issuer" + i, GetPartBy(part, 2, ','));
        SetElementLabel("expire" + i, GetPartBy(part, 3, ','));
        if ((elem = document.getElementById("view" + i)) != null) {
            if (GetPartBy(part, 4, ',') == "6") {
                elem.className = "view_link_ca";
            }
            else if (GetPartBy(part, 4, ',') == "64") {
                elem.className = "view_link_cert";
            }
            else {
                elem.className = "view_link_lock";
            }
        }
        i++;
    }
    return;
}
//-----------------------------------------------------------------------
// SetButtonValues
//-----------------------------------------------------------------------
function SetButtonValues(value) {
    if (value != null) {
        SetElementButton("btn_ok", GetPartBy(value, 0, ';'));
        SetElementButton("btn_cancel", GetPartBy(value, 1, ';'));
    }
    return;
}
//-----------------------------------------------------------------------
// CertificateNameToIndex
//-----------------------------------------------------------------------
function CertificateNameToIndex(element) {
    var index = 0;
    if (element.length > 4) {
        index = parseInt(element.substr(4));
    }
    return index;
}
//-----------------------------------------------------------------------
// OnButtonOK
//-----------------------------------------------------------------------
function OnButtonOK() {
    document.form1.action = "iid://exit";
    document.form1.submit();
    return;
}
//-----------------------------------------------------------------------
// OnCopy
//-----------------------------------------------------------------------
function OnCopy(text) {
    CopyClipboard(text);
    return;
}
//-----------------------------------------------------------------------
// OnCopyAll
//-----------------------------------------------------------------------
function OnCopyAll() {
    OnCopy(SLOTID);
    return;
}
//-----------------------------------------------------------------------
// OnCopyVariable
//-----------------------------------------------------------------------
function OnCopyVariable(id) {
    OnCopy(GetElementValue(id));
    return;
}
//-----------------------------------------------------------------------
// OnCopyCertificate
//-----------------------------------------------------------------------
function OnCopyCertificate(index) {
    var vars = GetVariablesHREF();
    var info = null;
    var value = "";
    if ((info = vars["certificates"]) != null) {
        info = GetPartBy(info, index, ';');
        value = GetPartBy(info, 0, ',');
        OnCopy(value);
        // Also view certificate
        OnViewCertificate(index);
    }
    return;
}
//-----------------------------------------------------------------------
// OnViewCertificate
//-----------------------------------------------------------------------
function OnViewCertificate(index) {
    var vars = GetVariablesHREF();
    var info = null;
    if ((info = vars["certificates"]) != null) {
        info = GetPartBy(info, index, ';');
        info = GetPartBy(info, 0, ',');
        document.form1.iid_set.value = "Certificate=" + URL.encode(info);
        document.form1.iid_invoke.value = "ViewCertificate";
        document.form1.action = "iid://plugin";
        document.form1.submit();
    }
    return;
}
