//-----------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------
var INFO_ID = null;
var INFO_LINK = null;
var SELECT_SHOW = false;
var IGNORE_SELECT_HIDE = false;
//-----------------------------------------------------------------------
// OnLoad
//-----------------------------------------------------------------------
function OnLoad() {
    var vars = null;
    if ((vars = GetVariablesHREF()) != null) {
        SetCurrentLanguage(vars);
        // Set all information
        SetInformation(vars);
    }
    return;
}
//-----------------------------------------------------------------------
// SetInformation
//-----------------------------------------------------------------------
function SetInformation(vars) {
    var value = null;
    var i = 0;
    if (vars != null) {
        INFO_ID = vars["id"];
        INFO_LINK = vars["info"];
        if (((value = vars["title"]) != null) && (value != "")) {
            SetInformationText("title", value);
        }
        if (((value = vars["subtitle"]) != null) && (value != "")) {
            SetInformationText("subtitle", value);
        }
        else {
            SetElementHidden("subtitle");
        }
        if (((value = vars["text"]) != null) && (value != "")) {
            SetInformationText("text", value);
        }
        else {
            SetElementHidden("info");
            SetElementVisible("line");
        }
        if (((value = vars["button"]) != null) && (value != "")) {
            SetElementValue("btn_open", value);
        }
        else {
            SetElementValue("btn_open", GetString("BUTTON_OPEN"));
        }
        if ((vars.indexOf("postpone") != -1) && SetInformationPostpone(vars["postpone"])) {
            SetElementValue("btn_close", GetString("BUTTON_POSTPONE"));
        }
        else {
            SetElementHidden("postpone");
        }
        if (((value = vars["image"]) != null) && (value != "")) {
            if ((i = value.indexOf("/")) != -1) {
                SetElementClass("logo", "back_logo_" + value.substr(i + 1));
                value = value.substr(0, i);
            }
            if (value != "") {
                SetElementClass("image", "image_logo_" + value);
            }
        }
    }
    return true;
}
//-----------------------------------------------------------------------
// SetInformationText
//-----------------------------------------------------------------------
function SetInformationText(elem, text) {
    var id = null;
    if ((id = INFO_ID) != null) {
        if (INFO_LINK != null) {
            id = "<a href='javascript:OnButtonInfo()' alt=''>" + id + "</a>";
        }
        text = ReplaceAll(text, "<id>", id);
        text = ReplaceAll(text, "\\n", "<br />");
    }
    SetElementValue(elem, text);
    return;    
}
//-----------------------------------------------------------------------
// SetInformationPostpone
//-----------------------------------------------------------------------
function SetInformationPostpone(value) {
    var count = 0;
    var maximum = 0;
    if ((value != null) && (value.length > 0)) {
        maximum = parseInt(value, 10)
    }
    if (maximum >= 60) {
        SetElementValue("option_1_hour", GetString("TEXT_1_HOUR"));
        count++;
    }
    else {
        SetElementHidden("option_1_hour");
    }
    if (maximum >= (60 * 24)) {
        SetElementValue("option_1_day", GetString("TEXT_1_DAY"));
        count++;
    }
    else {
        SetElementHidden("option_1_day");
    }
    if (maximum >= (7 * 60 * 24)) {
        SetElementValue("option_1_week", GetString("TEXT_1_WEEK"));
        count++;
    }
    else {
        SetElementHidden("option_1_week");
    }
    if (maximum >= (30 * 60 * 24)) {
        SetElementValue("option_1_month", GetString("TEXT_1_MONTH"));
        count++;
    }
    else {
        SetElementHidden("option_1_month");
    }
    return (count > 0);
}
//-----------------------------------------------------------------------
// OnButtonInfo
//-----------------------------------------------------------------------
function OnButtonInfo() {
    var value = null;
    if ((INFO_ID != null) && (INFO_LINK != null)) {
        value = ReplaceAll(INFO_LINK, "<id>", INFO_ID);
        if (iid_IsAvailable()) {
            iid_SetProperty("Location", value);
            iid_Invoke("View");
        }
    }
    return;
}
//-----------------------------------------------------------------------
// OnButtonOpen
//-----------------------------------------------------------------------
function OnButtonOpen() {
    OnActionDone(true);
    return;
}
//-----------------------------------------------------------------------
// OnButtonClose
//-----------------------------------------------------------------------
function OnButtonClose() {
    OnActionDone(false);
    return;
}
//-----------------------------------------------------------------------
// OnButtonSelectShow
//-----------------------------------------------------------------------
function OnButtonSelectShow() {
    IGNORE_SELECT_HIDE = true;
    SELECT_SHOW = true;
    OnButtonSelectUpdate();
    return;
}
//-----------------------------------------------------------------------
// OnButtonSelectHide
//-----------------------------------------------------------------------
function OnButtonSelectHide() {
    if (!IGNORE_SELECT_HIDE) {
        SELECT_SHOW = false;
    }
    IGNORE_SELECT_HIDE = false;
    OnButtonSelectUpdate();
    return;
}
//-----------------------------------------------------------------------
// OnButtonSelectUpdate
//-----------------------------------------------------------------------
function OnButtonSelectUpdate() {
    if (SELECT_SHOW) {
        SetElementClass("select_menu", "select_options");
    }
    else {
        SetElementClass("select_menu", "hidden");
    }
    return;
}
//-----------------------------------------------------------------------
// OnButtonSelect
//-----------------------------------------------------------------------
function OnButtonSelect(value) {
    document.form1.postpone.value = value;
    OnActionDone(false);
    return;
}
//-----------------------------------------------------------------------
// OnActionDone
//-----------------------------------------------------------------------
function OnActionDone(success) {
    if (success) {
        document.form1.status.value = "CKR_OK";
        document.form1.postpone.value = "";
    }
    else {
        document.form1.status.value = "CKR_CANCEL";
    }
    document.form1.action = "iid://exit";
    document.form1.submit();
    return;
}
