//-----------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------
var ACTION = null;
var LICENSE_ACCEPTED = false;
var SELECT_ACTIVE = false;
//-----------------------------------------------------------------------
// OnLoad
//-----------------------------------------------------------------------
function OnLoad() {
    var vars = null;
    if ((vars = GetVariablesHREF()) != null) {
        // Need to restore variables after "back" button, and will only
        // get result after setup finished
        value = vars["result"];
        if (vars.length <= 2) {
            vars = RestoreAllVariables();
        }
        else {
            vars = AppendToAllVariables(vars);
        }
        // Set all information
        SetInformation(vars);
        // Show result message when setup finished
        if (value != null) {
            ACTION = null;
            SetElementHidden("license");
            if (value == "CKR_OK") {
                ShowMessage(GetString("INFO_INSTALLATION_DONE"));
            }
            else {
                ShowError(GetString("ERROR_INSTALLATION_FAILED"));
            }
            SetElementLabel("text_btn_ok", GetString("BUTTON_EXIT"));
        }
        ShowHeader();
        // Capture key F5 (=refresh), will call OnReload below
        SetDetectReload();
    }
    return;
}
//-----------------------------------------------------------------------
// SetInformation
//-----------------------------------------------------------------------
function SetInformation(vars) {
    var value = null;
    // Set product information
    if ((value = vars["ProductInfo"]) != null) {
        SetProductInformation(value);
        // Fill list of languages
        FillLanguageList(vars);
    }
    if ((value = vars["button"]) != null) {
        SetElementLabel("text_btn_ok", FormatHTML(value));
    }
    SetElementValue("text_license", GetString("TEXT_LICENSE_AGREEMENT"));
    if (((ACTION = vars["action"]) != null) && (ACTION == "uninstall")) {
        SetElementHidden("license");
    }
    return;
}
//-----------------------------------------------------------------------
// OnExit
//-----------------------------------------------------------------------
function OnExit() {
    document.form1.action = "iid://exit";
    document.form1.submit();
    return;
}
//-----------------------------------------------------------------------
// OnReload
//-----------------------------------------------------------------------
function OnReload() {
    return;
}
//-----------------------------------------------------------------------
// OnButtonOK
//-----------------------------------------------------------------------
function OnButtonOK() {
    if (ACTION == null) {
        OnExit();
    }
    else  if (ACTION == "uninstall") {
        document.form1.action = "iid://uninstall";
        document.form1.submit();
        ShowProgress();
    }
    else {
        if (LICENSE_ACCEPTED) {
            document.form1.action = "iid://install";
            document.form1.submit();
            ShowProgress();
        }
        else {
            ShowError(GetString("TEXT_LICENSE_NOT_ACCEPTED"), GetString("INFO_LICENSE_NOT_ACCEPTED"));
        }
    }
    return;
}
//-----------------------------------------------------------------------
// OnLicenseCheck
//-----------------------------------------------------------------------
function OnLicenseCheck() {
    LICENSE_ACCEPTED = !LICENSE_ACCEPTED;
    if (LICENSE_ACCEPTED) {
        SetElementClass("chk_license", "checkbox_01");
    }
    else {
        SetElementClass("chk_license", "checkbox_00");
    }
    return;
}
//-----------------------------------------------------------------------
// OnLicenseView
//-----------------------------------------------------------------------
function OnLicenseView() {
    LoadPage("setup_license", null);
    return;
}
//-----------------------------------------------------------------------
// OnSelectClick
//-----------------------------------------------------------------------
function OnSelectClick() {
    if (SELECT_ACTIVE) {
        SELECT_ACTIVE = false;
        SetElementClass("select", "select");
    }
    else {
        SELECT_ACTIVE = true;
        SetElementClass("select", "select_active");
    }
    return;
}
//-----------------------------------------------------------------------
// OnSelectChange
//-----------------------------------------------------------------------
function OnSelectChange(value) {
    SetElementValue("language_current", value);
    SELECT_ACTIVE = false;
    SetElementClass("select", "select");
    if (value != GetCurrentLanguage()) {
        // Reload plugin variables and set new language for product
        value = "Config:Language:Current=" + URL.encode(value);
        LoadPluginVariables(value, null);
    }
    return;
}
//-----------------------------------------------------------------------
// FillLanguageList
//-----------------------------------------------------------------------
function FillLanguageList(vars) {
    var languages = null;
    var i = 0;
    var count = 0;
    var value = null;
    var elem = null;
    var elemValue = null;
    var elemInfo = "";
    // Need to get base element value
    if ((elem = document.getElementById("elem0")) != null) {
        if ((languages = CreateLanguageList(vars)) != null) {
            // Fill list of available languages (require present both internally and in product)
            while ((value = GetPartBy(languages, i, ',')) != "") {
                value = URL.decode(value);
                if (IsLanguageAvailable(value)) {
                    count++;
                    // Create element list element
                    elemValue = elem.innerHTML;
                    elemValue = ReplaceAll(elemValue, "ELEM_VALUE", value);
                    elemValue = ReplaceAll(elemValue, "ELEM_TEXT", FormatHTML(value));
                    // Append element to list of elements
                    elemInfo += elemValue;
                }
                i++;
            }
        }
        // Set new element value
        elem.innerHTML = elemInfo;
        // Set current language
        SetElementLabel("language_current", GetCurrentLanguage());
        SetElementDefaultImage("language_image", "language");
    }
    if (count == 0) {
        SetElementHidden("language");
    }
    return;
}
