//-----------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------
var SERVICES = null;
var BACK = null;
//-----------------------------------------------------------------------
// OnLoad
//-----------------------------------------------------------------------
function OnLoad() {
    var vars = null;
    // Should we restore plugin variables or are we setting a parameter
    if ((vars = GetVariablesHREF()) != null) {
        if (vars.length == 0) {
            vars = RestoreAllVariables();
        }
        else {
            vars = AppendToAllVariables(vars);
        }
    }
    // Set values dependning on parameters
    if (vars != null) {
        BACK = vars["back"];
        SetElementValue("title", GetString("TITLE_SUPPORT_SERVICES"));
        SetElementValue("add_service_name", GetString("TEXT_ADD_SERVICE"));
        SetElementValue("service_list_name", GetString("TEXT_ACTIVE_SERVICES"));
        SetElementValue("labelAddress", GetString("TEXT_ADDRESS"));
        FillServiceList();
        ShowHeader();
        SetElementVisible("content");
    }
    return;
}
//-----------------------------------------------------------------------
// OnBack
//-----------------------------------------------------------------------
function OnBack() {
    if (BACK == null) {
        LoadPage("support_adv", null);
    }
    else {
        LoadPage(BACK, null);
    }
    return;
}
//-----------------------------------------------------------------------
// OnUpdatePage
//-----------------------------------------------------------------------
function OnUpdatePage() {
    LoadPage("support_adv_service", null);
    return;
}
//-----------------------------------------------------------------------
// OnAddService
//-----------------------------------------------------------------------
function OnAddService() {
    var address = null;
    var service = null;
    var info = null;
    if ((address = GetElementValue("address")) != null) {
        if ((address.length == 0) || (address == GetString("TEXT_ADDRESS"))) {
            ShowError(GetString("ERROR_BAD_SERVICE_ADDRESS"), GetString("INFO_BAD_SERVICE_ADDRESS"));
        }
        else if (PresentServiceList(address)) {
            FillServiceList();
        }
        else if (address.toLowerCase() == "import test token") {
            ImportTestToken();
        }
        else if ((service = GetServiceInfo(address)) == null) {
            ShowError(GetString("ERROR_BAD_SERVICE_ADDRESS"), GetString("INFO_SERVICE_NOT_RESPONDING"));
        }
        else {
            AddServiceList(service)
            FillServiceList();
        }
    }
    return;
}
//-----------------------------------------------------------------------
// OnDeleteService
//-----------------------------------------------------------------------
function OnDeleteService(elem) {
    var index = 0;
    if (SERVICES != null) {
        if (elem.substr(0, 7) == "service") {
            index = parseInt(elem.substr(7));
            if (index < SERVICES.length) {
                ConfirmDelete(SERVICES[index], index);
            }
        }
    }
    return;
}
//-----------------------------------------------------------------------
// OnButtonOK
//-----------------------------------------------------------------------
function OnButtonOK() {
    OnAddService();
    return;
}
//-----------------------------------------------------------------------
// ConfirmDelete
//-----------------------------------------------------------------------
function ConfirmDelete(service, index) {
    ShowConfirm(GetString("CONFIRM_REMOVE_SERVICE"), GetString("INFO_REMOVE_SERVICE"), CallDeleteService, index);
    return;
}
//-----------------------------------------------------------------------
// FillServiceList
//-----------------------------------------------------------------------
function FillServiceList() {
    var list = null;
    var i = 0;
    var image = 0;
    // Hide current element list
    SetElementHidden("service_list");
    // Get list of all available services
    SERVICES = null;
    if ((list = CreateServiceList(true)) != null) {
        if (list.length > 0) {
            CreateElemList(list.length, "service", false);
            for (i = 0; i < list.length; i++) {
                SetElementLabel("servicename" + i, list[i].name);
                SetElementLabel("serviceinfo" + i, list[i].address);
                if ((list[i].version != null) && (list[i].version.length > 0)) {
                    SetElementValue("servicetext" + i, "v" + list[i].version);
                }
                if ((image = GetImageByPath(list[i].image, list[i].address)) != null) {
                    SetElementImage("serviceimage" + i, image);
                }
                else {
                    SetElementDefaultImage("serviceimage" + i, "service");
                }
            }
            SERVICES = list;
        }
    }
    // Show element list if available
    if (SERVICES != null) {
        SetElementVisible("service_list");
    }
    return;
}
//-----------------------------------------------------------------------
// CallDeleteService
//-----------------------------------------------------------------------
function CallDeleteService(index) {
    if ((SERVICES != null) && (SERVICES.length > index)) {
        RemoveServiceList(SERVICES[index].address);
        FillServiceList();
    }
    return;
}
