//-----------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------
var SLOTS = null;
var CERTIFICATES = null;
//-----------------------------------------------------------------------
// OnLoad
//-----------------------------------------------------------------------
function OnLoad() {
    var vars = null;
    if ((vars = GetVariablesHREF()) != null) {
        // Need to restore variables after "back" button 
        if (vars.length == 0) {
            vars = RestoreAllVariables();
        }
        else {
            vars = AppendToAllVariables(vars);
        }
        if (vars.length > 0) {
            DoLoadInfo(vars);
            SetTokenInfo();
            ShowElements(vars["ConfigGlobal:Administration:View"]);
            EnableElements();
            ShowHeader();
            SetElementVisible("content");
        }
        else {
            OnBack();
        }
    }
    return;
}
//-----------------------------------------------------------------------
// SetTokenInfo
//-----------------------------------------------------------------------
function SetTokenInfo() {
    var value = null;
    var name = null;
    var certificate = 0;
    if ((SLOTS != null) && (SLOTS.length > 0)) {
        value = StripParenthesisPart(SLOTS[0].token.label);
        name = value;
        SetElementLabel("name", value);
        if (SLOTS[0].slotid < 100) {
            SetElementLabel("text", SLOTS[0].token.number);
        }
        else {
            SetElementHidden("text");
        }
        if ((certificate = GetExpireCertificate()) != null) {
            SetElementLabel("info", certificate.validTo);
        }
        else {
            SetElementHidden("info");
        }
        if ((CERTIFICATES != null) && (CERTIFICATES.length > 0)) {
            value = CERTIFICATES[0].company;
            name = CERTIFICATES[0].name;
        }
        else {
            value = SLOTS[0].token.manufacturer;
        }
        SetElementLabel("title", name);
        if ((value = GetImageByName(value, false)) != null) {
            SetElementImage("image", value);
        }
        else {
            if (SLOTS[0].slotid < 100) {
                SetElementDefaultImage("image", "token_card");
            }
            else {
                SetElementDefaultImage("image", "token_soft");
            }
        }
        // Set all strings
        SetElementValue("actions", GetString("TEXT_ACTIONS"));
        SetElementValue("certificates_name", GetString("TEXT_CERTIFICATES"));
        SetElementValue("certificates_text", GetString("INFO_CERTIFICATES"));
        SetElementDefaultImage("certificates_image", "certificates");
        SetElementValue("change_name", GetString("TEXT_CHANGE_PIN"));
        SetElementValue("change_text", GetString("INFO_CHANGE_PIN"));
        SetElementDefaultImage("change_image", "change");
        SetElementValue("unlock_name", GetString("TEXT_UNLOCK_PIN"));
        SetElementValue("unlock_text", GetString("INFO_UNLOCK_PIN"));
        SetElementDefaultImage("unlock_image", "unlock");
        SetElementValue("renew_token_name", GetString("TEXT_RENEW_TOKEN"));
        SetElementValue("renew_token_text", GetString("INFO_RENEW_TOKEN"));
        SetElementDefaultImage("renew_token_image", "renew");
        SetElementValue("reset_token_name", GetString("TEXT_RESET_TOKEN"));
        SetElementValue("reset_token_text", GetString("INFO_RESET_TOKEN"));
        SetElementDefaultImage("reset_token_image", "reset");
        SetElementValue("delete_token_name", GetString("TEXT_DELETE_TOKEN"));
        SetElementValue("delete_token_text", GetString("INFO_DELETE_TOKEN"));
        SetElementDefaultImage("delete_token_image", "delete");
    }
    return;
}
//-----------------------------------------------------------------------
// OnBack
//-----------------------------------------------------------------------
function OnBack() {
    LoadPage("index", null);
    return;
}
//-----------------------------------------------------------------------
// OnCopy
//-----------------------------------------------------------------------
function OnCopy() {
    CopyClipboard(SLOTS[0].slotid);
    return;
}
//-----------------------------------------------------------------------
// OnCertificates
//-----------------------------------------------------------------------
function OnCertificates() {
    LoadPage("token_certs", PackTokenTypeInfo("certificates"));
    return;
}
//-----------------------------------------------------------------------
// OnChangePIN
//-----------------------------------------------------------------------
function OnChangePIN() {
    LoadPage("token_change", PackTokenTypeInfo("change"));
    return;
}
//-----------------------------------------------------------------------
// OnUnlockPIN
//-----------------------------------------------------------------------
function OnUnlockPIN() {
    LoadPage("token_change", PackTokenTypeInfo("unlock"));
    return;
}
//-----------------------------------------------------------------------
// OnResetToken
//-----------------------------------------------------------------------
function OnResetToken() {
    LoadPage("token_reset", PackTokenTypeInfo("reset_token"));
    return;
}
//-----------------------------------------------------------------------
// OnRenewToken
//-----------------------------------------------------------------------
function OnRenewToken() {
    var certificate = null;
    var value = "";
    if ((certificate = GetExpireCertificate()) != null) {
        document.form1.next.value = "none";
        value = "-renewcert";
        value += " -slotid " + certificate.slotid;
        value += " -certificate " + certificate.certID;
        value += " -expire " + certificate.expire;
        value = "Command=" + value;
        CallPluginComponent(document.form1.next.value, "plugin", value, "Run", "", "")
    }
    return;
}
//-----------------------------------------------------------------------
// OnDeleteToken
//-----------------------------------------------------------------------
function OnDeleteToken() {
    if ((SLOTS != null) && (SLOTS.length > 0)) {
        ShowConfirm(GetString("CONFIRM_DELETE_TOKEN"), null, CallDeleteToken, SLOTS[0].slotid);
    }
    return;
}
//-----------------------------------------------------------------------
// CallDeleteToken
//-----------------------------------------------------------------------
function CallDeleteToken(slotid) {
    ShowProgress();
    document.form1.next.value = "index.html";
    LoadPluginVariables("ActiveSlot=" + slotid, "DeleteToken");
    return;
}
//-----------------------------------------------------------------------
// GetExpireCertificate
//-----------------------------------------------------------------------
function GetExpireCertificate() {
    var certificate = null;
    var expire = null;
    var i = 0;
    // Get certificate with "lowest" specified expire value
    if (CERTIFICATES != null) {
        for (i=0; i<CERTIFICATES.length; i++) {
            if ((CERTIFICATES[i].expire != null) && (CERTIFICATES[i].expire.length > 0)) {
                if ((expire == null) || (parseInt(expire) > parseInt(CERTIFICATES[i].expire))) {
                    expire = CERTIFICATES[i].expire;
                    certificate = CERTIFICATES[i];
                }
            }
        }
    }
    return certificate;
}
//-----------------------------------------------------------------------
// PackTokenTypeInfo
//-----------------------------------------------------------------------
function PackTokenTypeInfo(type) {
    var value = "";
    value = "slotid=" + SLOTS[0].slotid + "&";
    if (type == "reset_token") {
        value += "token=" + SLOTS[0].token.label + "&";
    }
    else {
        value += "token=" + GetElementValue("name") + "&";
    }
    value += "type=" + type + "&";
    value += "title=" + GetElementValue(type + "_name") + "&";
    if ((CERTIFICATES != null) && (CERTIFICATES.length > 0)) {
        value += "name=" + URL.encode(CERTIFICATES[0].name) + "&";
        value += "company=" + URL.encode(CERTIFICATES[0].company) + "&";
    }
    else {
        value += "name=" + URL.encode(StripParenthesisPart(SLOTS[0].token.label)) + "&";
        value += "company=" + URL.encode(SLOTS[0].token.manufacturer) + "&";
    }
    return value;
}
//-----------------------------------------------------------------------
// DoLoadSlot
//-----------------------------------------------------------------------
function DoLoadInfo(vars) {
    var listToken = null;
    var listSlot = null;
    var listCert = null;
    // Get list of all available tokens/slots
    listToken = CreateTokenList(vars);
    if ((listSlot = CreateSlotList(vars, listToken)) != null) {
        // Get a list of certificates, first certificate for each slot 
        // be used as name (may be empty)
        listCert = CreateCertificateList(vars, null, listSlot[0].slotid, listSlot);
        // Store slots/certificates for use when clicked (OnViewSlot)
        SLOTS = listSlot;
        CERTIFICATES = listCert;
    }
    return;
}
//-----------------------------------------------------------------------
// EnableElements
//-----------------------------------------------------------------------
function EnableElements() {
    if ((SLOTS != null) && (SLOTS.length > 0)) {
        // Smart cards has slotid less than 100. PIN unlock and reset token 
        // only available for smart cards and soft tokens may be deleted if 
        // supported.
        if (SLOTS[0].slotid < 100) {
            SetElementHidden("delete_token");
        }
        else {
            SetElementHidden("unlock_pin");
            SetElementHidden("reset_token");
        }
        if ((CERTIFICATES == null) || (CERTIFICATES.length == 0)) {
            SetElementHidden("certificates");
        }
        if (GetExpireCertificate() == null) {
            SetElementHidden("renew_token");
        }
    }
    return;
}
//-----------------------------------------------------------------------
// ShowElements
//-----------------------------------------------------------------------
function ShowElements(view) {
    view = GetPartBy(GetPartBy(view, 0, ';'), 2, ',');
    ShowElementList(view, "certificates;change_pin;unlock_pin;copy_token;renew_token;reset_token;delete_token");
    return;
}
