//-----------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------
var CERTIFICATES = null;
//-----------------------------------------------------------------------
// OnLoad
//-----------------------------------------------------------------------
function OnLoad() {
    var vars = null;
    if ((vars = GetVariablesHREF()) != null) {
        // Need to restore variables after "back" button 
        if (vars.length == 0) {
            vars = RestoreAllVariables();
        }
        else {
            vars = AppendToAllVariables(vars);
        }
        if (vars.length > 0) {
            SetElementValue("title", GetString("TITLE_CERTIFICATES"));
            FillCertsList(vars);
            ShowHeader();
            // Show whole content
            SetElementVisible("content");
        }
        else {
            OnBack();
        }
    }
    return;
}
//-----------------------------------------------------------------------
// OnBack
//-----------------------------------------------------------------------
function OnBack() {
    LoadPage("token", null);
    return;
}
//-----------------------------------------------------------------------
// OnView
//-----------------------------------------------------------------------
function OnView(elem) {
    var i = 0;
    var count = 0;
    var type = elem.substr(0, 2);
    var index = parseInt(elem.substr(2));
    var certificate = null;
    var value = null;
    // Find the specified certificate
    for (i = 0; i < CERTIFICATES.length; i++) {
        if (((type == "ds") && (!CERTIFICATES[i].isCA) && (CERTIFICATES[i].usage != "64")) ||
            ((type == "nr") && (!CERTIFICATES[i].isCA) && (CERTIFICATES[i].usage == "64")) ||
            ((type == "ca") && (CERTIFICATES[i].isCA))) {
            if (index == count) {
                certificate = CERTIFICATES[i];
                break;
            }
            count++;
        }
    }
    // Load certificate page
    if (certificate != null) {
        value = "type=" + type + "&";
        value += "selected=" + URL.encode(PackCertificateInfo(certificate)) + "&";
        value += "back=token_certs";
        // Either open certificate action page or direct to details
        if (GetCustomFlagNoCertificateAction()) {
            type = "certificate_view";
        }
        else {
            type = "certificate";
        }
        LoadPage(type, value);
    }
    return;
}
//-----------------------------------------------------------------------
// FillCertsList
//-----------------------------------------------------------------------
function FillCertsList(vars) {
    var listToken = null;
    var listSlot = null;
    var listCert = null;
    var i = 0;
    var j = 0;
    var count = 0;
    var type = null;
    var label = null;
    var image = null;
    if ((listToken = CreateTokenList(vars)) != null) {
        if ((listSlot = CreateSlotList(vars, listToken)) != null) {
            if ((listCert = CreateCertificateList(vars, null, vars["slotid"], listSlot)) != null) {
                for (i = 0; i <= 2; i++) {
                    // First round DigSig certificates
                    // Second round NonRep certificates
                    // Third round CA certificates
                    count = 0;
                    for (j = 0; j < listCert.length; j++) {
                        if (((i == 0) && (!listCert[j].isCA) && (listCert[j].usage != "64")) ||
                            ((i == 1) && (!listCert[j].isCA) && (listCert[j].usage == "64")) ||
                            ((i == 2) && (listCert[j].isCA))) {
                            count++;
                        }
                    }
                    if (count > 0) {
                        switch (i) {
                            case 0: type = "ds"; label = GetString("TEXT_CERT_DS"); break;
                            case 1: type = "nr"; label = GetString("TEXT_CERT_NR"); break;
                            case 2: type = "ca"; label = GetString("TEXT_CERT_CA"); break;
                        }
                        // Create element list and set title for each round
                        CreateElemList(count, type, true);
                        SetElementLabel(type + "title", label);
                        // Enumerate all certificates and set matching round
                        count = 0;
                        for (j = 0; j < listCert.length; j++) {
                            if (((i == 0) && (!listCert[j].isCA) && (listCert[j].usage != "64")) ||
                                ((i == 1) && (!listCert[j].isCA) && (listCert[j].usage == "64")) ||
                                ((i == 2) && (listCert[j].isCA))) {
                                // Set certificate info
                                SetElementLabel(type + "name" + count, listCert[j].name);
                                if (listCert[j].company != null) {
                                    SetElementLabel(type + "info" + count, listCert[j].company);
                                }
                                else {
                                    SetElementHidden(type + "info" + count);
                                }
                                //SetElementValue(type + "text" + count, listCert[j].validTo);
                                SetElementHidden(type + "text" + count);
                                if ((image = GetCertificateImageByName(listCert[j])) != null) {
                                    SetElementImage(type + "image" + count, image);
                                }
                                else {
                                    SetElementDefaultImage(type + "image" + count, "certificate_" + type);
                                }
                                count++;
                            }
                        }
                    }
                }
            }
        }
        CERTIFICATES = listCert;
    }
    return;
}
