//-----------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------
var SLOTID = null;
var TYPE = null;
var RESULT = null;
var SELECT_ACTIVE = false;
var IGNORE_SELECT_ABORT = false;
//-----------------------------------------------------------------------
// OnLoad
//-----------------------------------------------------------------------
function OnLoad() {
    var vars = null;
    var value = null;
    if ((vars = GetVariablesHREF()) != null) {
        // Get result from submit
        RESULT = vars["result"];
        // Need to restore variables after submit
        if ((TYPE = vars["type"]) == null) {
            vars = RestoreAllVariables();
        }
        else {
            vars = AppendToAllVariables(vars);
        }
        // Type is always present 
        if ((TYPE = vars["type"]) != null) {
            if ((value = vars["title"]) != null) {
                SetElementLabel("title", value);
                SetElementLabel("text_btn_ok", value);
            }
            if ((value = vars["name"]) != null) {
                SetElementLabel("name", value);
            }
            if ((value == vars["token"]) ||
                ((value = vars["token"]) == null)) {
                SetElementHidden("token");
            }
            else {
                SetElementLabel("token", value);
            }
            if (((value = vars["company"]) != null) &&
                ((value = GetImageByName(value, false)) != null)) {
                SetElementImage("image", value);
            }
            else if ((TYPE == "change") || (TYPE == "unlock")) {
                SetElementDefaultImage("image", TYPE);
            }
            FillSelectList(vars);
            if (RESULT != null) {
                setTimeout(OnResultChange, 33);
            }
            // Update edit field labels
            UpdateLanguage();
            ShowHeader();
            // Show whole content
            SetElementVisible("content");
            // Set focus on old password field
            if (RESULT == null) {
                SetFieldFocus("pwd_old");
            }
        }
    }
    return;
}
//-----------------------------------------------------------------------
// UpdateLanguage
//-----------------------------------------------------------------------
function UpdateLanguage() {
    if (TYPE == "change") {
        SetElementLabel("label_password", GetString("TEXT_PIN"));
    }
    else {
        SetElementLabel("label_password", GetString("TEXT_PUK"));
    }
    SetElementLabel("label_newpassword", GetString("TEXT_NEWPIN"));
    SetElementLabel("label_confirmpassword", GetString("TEXT_CONFIRMPIN"));
    return;
}
//-----------------------------------------------------------------------
// OnResultChange
//-----------------------------------------------------------------------
function OnResultChange() {
    if (RESULT == "CKR_OK") {
        if (TYPE == "change") {
            ShowMessage(GetString("INFO_PIN_CHANGED"));
        }
        else {
            ShowMessage(GetString("INFO_PIN_UNLOCKED"));
        }
    }
    else {
        ShowErrorPkcs11(RESULT);
    }
    return;
}
//-----------------------------------------------------------------------
// OnBack
//-----------------------------------------------------------------------
function OnBack() {
    LoadPage("token", null);
    return;
}
//-----------------------------------------------------------------------
// OnButtonOK
//-----------------------------------------------------------------------
function OnButtonOK() {
    var result = null;
    var value = null;
    var pwd_old = GetElementValue("pwd_old");
    var pwd_new = GetElementValue("pwd_new");
    var pwd_confirm = GetElementValue("pwd_confirm");
    // Store current slotid
    ReplaceForAllVariables("slotid", SLOTID);
    // Require confirm and new password are equal
    if (pwd_confirm != pwd_new) {
        result = "CKR_PINS_NOT_EQUAL";
    }
    else if (pwd_new.length == 0) {
        result = "CKR_PIN_INVALID";
    }
    else {
        value = "ActiveSlot=" + SLOTID + ";";
        if (TYPE == "unlock") {
            value += "UnlockPassword=" + URL.encode(pwd_old) + ";";
        }
        else {
            value += "Password=" + URL.encode(pwd_old) + ";";
        }
        value += "NewPassword=" + URL.encode(pwd_new) + ";";
        ShowProgress();
        CallPluginComponent(document.form1.next.value, "plugin", value, TYPE + "Password", "", "")
    }
    if (result != null) {
        RESULT = result;
        OnResultChange();
    }
    return;
}
//-----------------------------------------------------------------------
// OnSelectClick
//-----------------------------------------------------------------------
function OnSelectClick() {
    IGNORE_SELECT_ABORT = true;
    if (SELECT_ACTIVE) {
        SELECT_ACTIVE = false;
        SetElementClass("select", "select");
    }
    else {
        SELECT_ACTIVE = true;
        SetElementClass("select", "select_active");
    }
    return;
}
//-----------------------------------------------------------------------
// OnSelectAbort
//-----------------------------------------------------------------------
function OnSelectAbort() {
    if (!IGNORE_SELECT_ABORT) {
        SELECT_ACTIVE = false;
        SetElementClass("select", "select");
    }
    IGNORE_SELECT_ABORT = false;
    return;
}
//-----------------------------------------------------------------------
// OnSelectChange
//-----------------------------------------------------------------------
function OnSelectChange(value) {
    SLOTID = GetPartBy(value, 0, ':');
    SetElementValue("select_current", GetPartBy(value, 1, ':'));
    SELECT_ACTIVE = false;
    SetElementClass("select", "select");
    return;
}
//-----------------------------------------------------------------------
// FillSelectList
//-----------------------------------------------------------------------
function FillSelectList(vars) {
    var listToken = null;
    var listSlot = null;
    var listSelect = null;
    var count = 0;
    var i = 0;
    var value = null;
    var text = null;
    var elem = null;
    var elemValue = null;
    var elemInfo = "";
    // Set active slotid
    SLOTID = vars["slotid"];
    // Need to get base element value
    if ((elem = document.getElementById("elem0")) != null) {
        if ((listToken = CreateTokenList(vars)) != null) {
            if ((listSlot = CreateSlotList(vars, listToken)) != null) {
                // Only need select box when more than one pin
                if (listToken.length > 1) {
                    for (i = 0; i < listToken.length; i++) {
                        if (IsSlotConnected(listToken[i].slotid, SLOTID, listSlot)) {
                            count++;
                            text = GetParenthesisPart(listToken[i].label);
                            text = text.substr(0, 1).toUpperCase() + text.substr(1);
                            value = listToken[i].slotid + ":" + text;
                            // Create element list element
                            elemValue = elem.innerHTML;
                            elemValue = ReplaceAll(elemValue, "ELEM_VALUE", value);
                            elemValue = ReplaceAll(elemValue, "ELEM_TEXT", text);
                            // Append element to list of elements
                            elemInfo += elemValue;
                            // Set current value
                            if (listToken[i].slotid == SLOTID) {
                                SetElementValue("select_current", GetPartBy(value, 1, ':'));
                            }
                        }
                    }
                }
                // Set new element value
                elem.innerHTML = elemInfo;
            }
        }
    }
    if (count <= 1) {
        // Hide select box when nothing to select
        SetElementHidden("select_pin");
    }
    return;
}
