//-----------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------
var ACTION = null;
var INFO_ID = null;
var INFO_LINK = null;
var MODE = null;
var VERSION = 0;
var SIZE = 0;
var CURRENT = 0;
//-----------------------------------------------------------------------
// OnLoad
//-----------------------------------------------------------------------
function OnLoad() {
    var vars = null;
    if ((vars = GetVariablesHREF()) != null) {
        // Set all information
        SetInformation(vars);
    }
    return;
}
//-----------------------------------------------------------------------
// SetInformation
//-----------------------------------------------------------------------
function SetInformation(vars) {
    var success = false;
    var value = null;
    // Action must be present
    if ((value = UpdateAction(vars["action"], vars["mode"])) != null) {
        // Action search, download or upgrade
        if (value == "search") {
            success = SetInformationSearch(vars);
        }
        else if (value == "download") {
            success = SetInformationDownload(vars);
        }
        else if (value == "upgrade") {
            success = SetInformationUpgrade(vars);
        }
        UpdateButton(value);
    }
    return success;
}
//-----------------------------------------------------------------------
// SetInformationDefault
//-----------------------------------------------------------------------
function SetInformationDefault(vars) {
    var value = null;
    var info = null;
    if (vars != null) {
        INFO_ID = vars["id"];
        INFO_LINK = vars["link"];
        VERSION = vars["version"];
        if (((value = vars["ProductInfo"]) != null) && (value != "")) {
            if ((info = new ProductInformation(value)) != null) {
                ReloadStringTable(info.language);
                SetElementValue("title", info.productName + " " + GetString("TITLE_UPDATE"));
                SetElementValue("versionText", info.productVersion);
            }
        }
        if (((value = vars["searchDate"]) != null) && (value != "")) {
            SetElementValue("searchText", FormatDate(value));
        }
        else {
            SetElementValue("searchText", GetString("TEXT_NEVER"));
        }
        if (((value = vars["packageDate"]) != null) && (value != "")) {
            SetElementValue("updateText", FormatDate(value));
        }
        else {
            SetElementValue("updateText", GetString("TEXT_NEVER"));
        }
        SetElementValue("versionName", GetString("TEXT_CURRENT_VERSION"));
        SetElementValue("updateName", GetString("TEXT_LAST_UPDATE"));
        SetElementValue("searchName", GetString("TEXT_LAST_SEARCH"));
        SetElementValue("btn_close", GetString("BUTTON_EXIT"));
        if (((value = vars["title"]) != null) && (value != "")) {
            SetInformationText("title", value);
        }
        if (((value = vars["subtitle"]) != null) && (value != "")) {
            SetInformationText("subtitle", value);
        }
    }
    return true;
}
//-----------------------------------------------------------------------
// SetInformationSearch
//-----------------------------------------------------------------------
function SetInformationSearch(vars) {
    SetInformationDefault(vars);
    INFO = GetString("TEXT_STATUS_SEARCH");
    SetStatusText();
    return true;
}
//-----------------------------------------------------------------------
// SetInformationDownload
//-----------------------------------------------------------------------
function SetInformationDownload(vars) {
    var value = null;
    SIZE = 0;
    SetInformationDefault(vars);
    if ((value = vars["size"]) != null) {
        SIZE = parseInt(value, 10);
    }
    INFO = GetString("TEXT_STATUS_DOWNLOAD");
    SetStatusText();
    return true;
}
//-----------------------------------------------------------------------
// SetInformationUpgrade
//-----------------------------------------------------------------------
function SetInformationUpgrade(vars) {
    var value = null;
    SIZE = 0;
    SetInformationDefault(vars);
    if ((value = vars["size"]) != null) {
        SIZE = parseInt(value, 10);
    }
    INFO = GetString("TEXT_STATUS_UPGRADE");
    SetStatusText();
    return true;
}
//-----------------------------------------------------------------------
// SetInformationText
//-----------------------------------------------------------------------
function SetInformationText(elem, text) {
    var id = null;
    if ((id = INFO_ID) != null) {
        if (INFO_LINK != null) {
            id = "<a href='javascript:OnButtonInfo()' alt=''>" + id + "</a>";
        }
        text = ReplaceAll(text, "<id>", id);
        text = ReplaceAll(text, "\\n", "<br />");
    }
    SetElementValue(elem, text);
    return;
}
//-----------------------------------------------------------------------
// SetStatusText
//-----------------------------------------------------------------------
function SetStatusText(info) {
    if (info == null) {
        info = INFO;
    }
    info = ReplaceAll(info, "<size>", FormatSize(SIZE));
    info = ReplaceAll(info, "<version>", FormatVersion(VERSION));
    SetElementValue("text", info);
    return;
}
//-----------------------------------------------------------------------
// OnButtonAction
//-----------------------------------------------------------------------
function OnButtonAction() {
    var value = null;
    if ((value = GetAction()) == null) {
        OnActionExit(false);
    }
    else if (value == "search") {
        OnActionSearch();
    }
    else if (value == "download") {
        OnActionDownload();
    }
    else if (value == "upgrade") {
        OnActionUpgrade();
    }
    return;
}
//-----------------------------------------------------------------------
// OnButtonInfo
//-----------------------------------------------------------------------
function OnButtonInfo() {
    var value = null;
    if (INFO_LINK != null) {
        value = ReplaceAll(INFO_LINK, "<id>", INFO_ID);
        if (iid_IsAvailable()) {
            iid_SetProperty("Location", value);
            iid_Invoke("View");
        }
    }
    return;
}
//-----------------------------------------------------------------------
// OnActionExit
//-----------------------------------------------------------------------
function OnActionExit(success) {
    if (success) {
        document.form1.status.value = "CKR_OK";
    }
    else {
        document.form1.status.value = "CKR_CANCEL";
    }
    document.form1.action = "iid://exit";
    document.form1.submit();
    return;
}
//-----------------------------------------------------------------------
// OnActionSearch
//-----------------------------------------------------------------------
function OnActionSearch() {
    var rc = 0;0
    CURRENT = 0;
    if (iid_IsAvailable()) {
        SetStatusText(GetString("TEXT_STATUS_SEARCHING"));
        iid_SetProperty("InvokeThread", "false");
        if ((rc = iid_Invoke("UpgradeSearch")) != 0) {
            ShowError(GetString("ERROR_SEARCH_UPGRADE"), null);
        }
        else {
            ProgressShow(false);
            OnStatusSearch();
        }
    }
    return;
}
//-----------------------------------------------------------------------
// OnStatusSearch
//-----------------------------------------------------------------------
function OnStatusSearch() {
    var completed = false;
    var value = null;
    // First check for invoke thread status
    if (((value = iid_GetProperty("InvokeResult")) != null) && (value != "")) {
        // Value '144' = CKR_OPERATION_ACTIVE; so accept all other
        if (value != "144") {
            if (((value = iid_GetProperty("Progress")) != null) && (value != "")) {
                if (ActionCompleted(value)) {
                    // Check downloaded upgrade package and require we can get information
                    if ((iid_Invoke("UpgradeCheck") != 0) ||
                        ((value = iid_GetProperty("Data")) == null) ||
                        ((vars = GetVariablesHREF(value)) == null) ||
                        !SetInformation(vars)) {
                        // Something bad happened (always handle as new search)
                        SetInformationDefault();
                    }
                    ProgressHide();
                    completed = true;
                }
            }
        }
    }
    if (!completed) {
        setTimeout(OnStatusSearch, 333);
    }
    return;
}
//-----------------------------------------------------------------------
// OnActionDownload
//-----------------------------------------------------------------------
function OnActionDownload() {
    var rc = 0;
    CURRENT = 0;
    if (iid_IsAvailable()) {
        iid_SetProperty("InvokeThread", "false");
        if ((rc = iid_Invoke("UpgradeDownload")) != 0) {
            ShowError(GetString("ERROR_DOWNLOAD_UPGRADE"), null);
        }
        else {
            ProgressShow(true);
            OnStatusDownload();
        }
    }
    return;
}
//-----------------------------------------------------------------------
// OnStatusDownload
//-----------------------------------------------------------------------
function OnStatusDownload() {
    var completed = false;
    var value = null;
    if (((value = iid_GetProperty("Progress")) != null) && (value != "")) {
        if (ActionCompleted(value)) {
            UpdateAction("upgrade");
            ProgressHide();
            completed = true;
        }
    }
    if (!completed) {
        setTimeout(OnStatusDownload, 111);
    }
    return;
}
//-----------------------------------------------------------------------
// OnActionUpgrade
//-----------------------------------------------------------------------
function OnActionUpgrade() {
    if (iid_IsAvailable()) {
        SetStatusText(GetString("TEXT_STATUS_UPGRADING"));
        iid_SetProperty("InvokeThread", "true");
        if (iid_Invoke("UpgradeStart") != 144) {
            ShowError(GetString("ERROR_START_UPGRADE"), null);
        }
        else {
            ProgressShow(false);
            OnStatusUpgrade();
        }
    }
    return;
}
//-----------------------------------------------------------------------
// OnStatusUpgrade
//-----------------------------------------------------------------------
function OnStatusUpgrade() {
    var completed = false;
    var value = null;
    // First check for invoke thread status
    if (((value = iid_GetProperty("InvokeResult")) != null) && (value != "")) {
        // Value '144' = CKR_OPERATION_ACTIVE; so accept all other
        if (value != "144") {
            OnActionExit(value == "0");
            completed = true;
        }
        else {
            UpdateProgressLooping();
        }
    }
    if (!completed) {
        setTimeout(OnStatusUpgrade, 111);
    }
    return;
}
//-----------------------------------------------------------------------
// ActionCompleted
//-----------------------------------------------------------------------
function ActionCompleted(value) {
    var part = null;
    var size = 0;
    var total = 0;
    // Completed when total and size are equal
    if ((part = GetPartBy(value, 0, ';')) != "") {
        size = parseInt(part, 10);
    }
    if ((part = GetPartBy(value, 1, ';')) != "") {
        if ((total = parseInt(part, 10)) == 0) {
            total = SIZE;
        }
    }
    // Alaso update current status
    UpdateProgressPrecent(size, total);
    return (size == total);
}
//-----------------------------------------------------------------------
// ProgressShow
//-----------------------------------------------------------------------
function ProgressShow(percent) {
    if (percent) {
        SetElementVisible("progress_percent");
        SetElementHidden("progress_looping");
        UpdateProgressPrecent(0, 0);
    }
    else {
        SetElementHidden("progress_percent");
        SetElementVisible("progress_looping");
        UpdateProgressLooping();
    }
    return;
}
//-----------------------------------------------------------------------
// ProgressHide
//-----------------------------------------------------------------------
function ProgressHide() {
    SetElementVisible("progress_percent");
    SetElementHidden("progress_looping");
    UpdateProgressPrecent(0, 0);
    return;
}
//-----------------------------------------------------------------------
// UpdateProgressPrecent
//-----------------------------------------------------------------------
function UpdateProgressPrecent(current, size) {
    var elem = null;
    var percent = 0;
    // Avoid divide by zero (used when hide progress)
    if (size == 0) {
        current = 0;
        size = 1;
    }
    // Update those elements that are available
    if ((elem = document.getElementById("progressBar")) != null) {
        percent = Math.floor((20 * current) / size) * 5;
        elem.style.width = percent + "%";
    }
    if ((elem = document.getElementById("progressCount")) != null) {
        percent = Math.floor((100 * current) / size);
        elem.innerHTML = percent + "%";
    }
    if ((current == 0) && (size == 1)) {
        SetStatusText(null);
    }
    else {
        SetStatusText(FormatProgress(current, size));
    }
    return;
}
//-----------------------------------------------------------------------
// UpdateProgressLooping
//-----------------------------------------------------------------------
function UpdateProgressLooping(name) {
    CURRENT += 5;
    if (CURRENT > 120) {
        CURRENT = 0;
    }
    UpdateProgressLooping2(CURRENT, name);
    return;
}
//-----------------------------------------------------------------------
// UpdateProgressLooping2
//-----------------------------------------------------------------------
function UpdateProgressLooping2(percent, name) {
    var elem = null;
    var left = 0;
    var right = 0;
    // Percent value is between 0 and 120, since 100 for complete bar and 
    // 20 for of moving bar.
    if ((percent >= 0) && (percent <= 120)) {
        if (name == null) {
            name = "progress";
        }
        if ((elem = document.getElementById(name + "Left")) != null) {
            if (percent > 100) {
                right = 20 - (percent - 100);
                left = 100 - right;
            }
            else if (percent < 20) {
                left = 0;
                right = percent;
            }
            else {
                left = percent - 20;
                right = 20;
            }
            left = Math.floor(left / 5) * 5;
            right = Math.floor(right / 5) * 5;
            elem.style.width = left + "%";
            if ((elem = document.getElementById(name + "Right")) != null) {
                elem.style.width = right + "%";
            }
        }
    }
    return;
}
//-----------------------------------------------------------------------
// UpdateAction
//-----------------------------------------------------------------------
function UpdateAction(action, mode) {
    if (action != null) {
        ACTION = action.toLowerCase();
        action = GetAction();
        UpdateButton(action);
        if (AutoPushActionButton()) {
            setTimeout(OnButtonOK, 111);
        }
    }
    return action;
}
//-----------------------------------------------------------------------
// GetAction
//-----------------------------------------------------------------------
function GetAction() {
    return ACTION;
}
//-----------------------------------------------------------------------
// UpdateButton
//-----------------------------------------------------------------------
function UpdateButton(type) {
    if (type == "search") {
        SetElementValue("btn_action", GetString("BUTTON_SEARCH"));
    }
    else if (type == "download") {
        SetElementValue("btn_action", GetString("BUTTON_DOWNLOAD"));
    }
    else if (type == "upgrade") {
        SetElementValue("btn_action", GetString("BUTTON_UPGRADE"));
    }
    return;
}
//-----------------------------------------------------------------------
// AutoPushActionButton
//-----------------------------------------------------------------------
function AutoPushActionButton() {
    var push = false;
    var value = null;
    var auto = 0;
    var action = null;
    if ((action = GetAction()) != null)
    {
        if (MODE != null) {
            if ((value = GetPartBy(MODE, 3, '/')) != "") {
                auto = parseInt(value, 10);
                if ((((auto & 0x01) == 0x01) && (action == "search")) ||
                    (((auto & 0x02) == 0x02) && (action == "download")) ||
                    (((auto & 0x04) == 0x04) && (action == "upgrade"))) {
                    // Auto push action button
                    push = true;
                }
            }
        }
    }
    return push;
}
//-----------------------------------------------------------------------
// FormatDate
//-----------------------------------------------------------------------
function FormatDate(value) {
    var date = null;
    if (value.length >= 14) {
        date = new Date(
            parseInt(value.substr(0, 4), 10),
            parseInt(value.substr(4, 2), 10) - 1,
            parseInt(value.substr(6, 2), 10),
            parseInt(value.substr(8, 2), 10),
            parseInt(value.substr(10, 2), 10),
            parseInt(value.substr(12, 2), 10));
        value = date.toLocaleDateString() + " " + date.toLocaleTimeString();
    }
    return value;
}
//-----------------------------------------------------------------------
// FormatProgress
//-----------------------------------------------------------------------
function FormatProgress(current, size) {
    var value = "";
    var percent = 0;
    percent = Math.floor((100 * current) / size);
    value = GetString("TEXT_STATUS_DOWNLOADING");
    value = ReplaceAll(value, "<current>", FormatSize(current));
    value = ReplaceAll(value, "<size>", FormatSize(size));
    value = ReplaceAll(value, "<percent>", percent);
    return value;
}
